<?php
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: CGBlog (c) 2010 by Robert Campbell 
#         (calguy1000@cmsmadesimple.org)
#  An addon module for CMS Made Simple to allow creation, management of
#  and display of blog articles.
# 
#-------------------------------------------------------------------------
# CMS - CMS Made Simple is (c) 2005 by Ted Kulp (wishy@cmsmadesimple.org)
# This project's homepage is: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin 
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE
if (!isset($gCms)) exit;
$config = $gCms->GetConfig();

if( !isset($params['articleid']) )
  {
    exit; // nothing to do.
  }

$canviewdraft = 0;
{
  $feu = cge_utils::get_module('FrontEndUsers');
  $gid = $this->GetPreference('fesubmit_draftviewers',-1);
  if( $gid > 0 )
    {
      if( $feu->MemberOfGroup($feu->LoggedInId(),$gid) )
	{
	  $canviewdraft = 1;
	}
    }
}

$query = '';
$row = '';
if( $params['articleid'] == -1 )
  {
    // get the latest, valid cgblog article.
    $now = $db->DbTimeStamp(time());
    $query = "SELECT mn.* FROM ".cms_db_prefix()."module_cgblog mn WHERE";
    if( !$canviewdraft )
      {
	$query .= " status = 'published' AND ";
      }
    $query .= " (".$db->IfNull('start_time',$db->DBTimeStamp(1))." < $now) AND ";
    $query .= "((".$db->IfNull('end_time',$db->DBTimeStamp(1))." = ".$db->DBTimeStamp(1).") OR (end_time > $now)) ";
    $query .= 'ORDER BY end_time,start_time DESC LIMIT 1';
    $row = $db->GetRow($query);

    // todo, should we 404 here?
    if( !$row ) return;
  }
else
  {
    $query = "SELECT mn.* FROM ".cms_db_prefix()."module_cgblog mn WHERE";
    if( !$canviewdraft )
      {
	$query .= " status = 'published' AND ";
      }
    $query .= " cgblog_id = ?";
    $row = $db->GetRow($query, array($params['articleid']));

    // todo, should we 404 here?
    if( !$row ) return;
  }

if ($row)
  {
    $onerow = new stdClass();

    $onerow->id = $row['cgblog_id'];
    $onerow->author = $row['author'];
    $onerow->title = $row['cgblog_title'];
    $onerow->content = $row['cgblog_data'];
    $onerow->summary = $row['summary'];
    $onerow->postdate = $row['cgblog_date'];
    $onerow->postdate = $row['cgblog_date'];
    $onerow->startdate = $row['start_time'];
    $onerow->enddate = $row['end_time'];
    $onerow->extra = $row['cgblog_extra'];

    // handle canonical URL
    $aliased_title = munge_string_to_url($row['cgblog_title']);
    $prettyurl = $this->GetPreference('urlprefix','cgblog').'/'.$row['cgblog_id']."/$returnid/$aliased_title";
    if( $this->GetPreference('default_detailpage',-1) != -1 )
      {
	$prettyurl = $this->GetPreference('urlprefix','cgblog').'/'.$row['cgblog_id']."/$aliased_title";
      }
    if (isset($sendtodetail['detailtemplate']))
      {
	$prettyurl .= '/d,' . $sendtodetail['detailtemplate'];
      }
    $onerow->canonical = $this->CreateLink($id, 'detail', $returnid, 
					   '', $params, '', true, false, '', true, $prettyurl);


    //
    // Handle categories
    //
    {
      $query = 'SELECT A.category_id,B.name 
                  FROM '.cms_db_prefix().'module_cgblog_blog_categories A
                  LEFT JOIN '.cms_db_prefix().'module_cgblog_categories B
                    ON A.category_id = B.id
                 WHERE A.blog_id = ?';
      $tmp = $db->GetArray($query,array($row['cgblog_id']));
      if( is_array($tmp) )
	{
	  $onerow->categories = $tmp;
	}
    }


    //
    // Handle the custom fields
    //
    $query3 = 'SELECT A.value,B.id,B.name,B.type FROM '.cms_db_prefix().'module_cgblog_fieldvals A, '.cms_db_prefix().'module_cgblog_fielddefs B WHERE A.fielddef_id = B.id AND A.cgblog_id = ? AND B.public = 1 ORDER BY B.item_order';
    $dbr3 = $db->Execute($query3,array($row['cgblog_id']));
    $fields = array();
    $fieldsbyname = array();
    while( $dbr3 && ($row3 = $dbr3->FetchRow()) )
      {
	$alias = strtolower(str_replace(' ','_',$row3['name']));
	$onerow->$alias = $row3['value'];
				
	$obj = new StdClass();
	foreach( $row3 as $k => $v )
	  {
	    $obj->$k = $v;
	  }
	$fields[] = $obj;
	$fieldsbyname[$alias] = $obj;
      }
    $onerow->fieldsbyname = $fieldsbyname;
    $onerow->fields = $fields;
    $onerow->file_location = $config['uploads_url'].'/cgblog/id'.$row['cgblog_id'];

    $this->smarty->assign_by_ref('entry', $onerow);
  }

$smarty->assign('category_label', $this->Lang('category_label'));
$smarty->assign('author_label', $this->Lang('author_label'));

#Display template
$template = 'detail'.$this->GetPreference('current_detail_template');
if (isset($params['detailtemplate']))
  {
    $template = 'detail'.$params['detailtemplate'];
  }
echo $this->ProcessTemplateFromDatabase($template);
# vim:ts=4 sw=4 noet
?>
